import { vitest } from 'vitest';
import { type RouteLocation } from 'vue-router';

import { type MountingOptions, shallowMount } from '@vue/test-utils';
import sinon, { type SinonStubbedInstance } from 'sinon';

import AlertService from '@/shared/alert/alert.service';

import LiberatoriaDetails from './liberatoria-details.vue';
import LiberatoriaService from './liberatoria.service';

type LiberatoriaDetailsComponentType = InstanceType<typeof LiberatoriaDetails>;

let route: Partial<RouteLocation>;
const routerGoMock = vitest.fn();

vitest.mock('vue-router', () => ({
  useRoute: () => route,
  useRouter: () => ({ go: routerGoMock }),
}));

const liberatoriaSample = { id: 123 };

describe('Component Tests', () => {
  let alertService: AlertService;

  afterEach(() => {
    vitest.resetAllMocks();
  });

  describe('Liberatoria Management Detail Component', () => {
    let liberatoriaServiceStub: SinonStubbedInstance<LiberatoriaService>;
    let mountOptions: MountingOptions<LiberatoriaDetailsComponentType>['global'];

    beforeEach(() => {
      route = {};
      liberatoriaServiceStub = sinon.createStubInstance<LiberatoriaService>(LiberatoriaService);

      alertService = new AlertService({
        i18n: { t: vitest.fn() } as any,
        toast: {
          show: vitest.fn(),
        } as any,
      });

      mountOptions = {
        stubs: {
          'font-awesome-icon': true,
          'router-link': true,
        },
        provide: {
          alertService,
          liberatoriaService: () => liberatoriaServiceStub,
        },
      };
    });

    describe('Navigate to details', () => {
      it('Should call load all on init', async () => {
        // GIVEN
        liberatoriaServiceStub.find.resolves(liberatoriaSample);
        route = {
          params: {
            liberatoriaId: `${123}`,
          },
        };
        const wrapper = shallowMount(LiberatoriaDetails, { global: mountOptions });
        const comp = wrapper.vm;
        // WHEN
        await comp.$nextTick();

        // THEN
        expect(comp.liberatoria).toMatchObject(liberatoriaSample);
      });
    });

    describe('Previous state', () => {
      it('Should go previous state', async () => {
        liberatoriaServiceStub.find.resolves(liberatoriaSample);
        const wrapper = shallowMount(LiberatoriaDetails, { global: mountOptions });
        const comp = wrapper.vm;
        await comp.$nextTick();

        comp.previousState();
        await comp.$nextTick();

        expect(routerGoMock).toHaveBeenCalledWith(-1);
      });
    });
  });
});
